#include <stdio.h>

#include "dmac.h"
#include <math.h>
#include "fft.h"

#define FFT_FORWARD_SHIFT   0x0ff
#define FFT_N               512

int16_t  ad_buf[FFT_N];
uint64_t databuf512[FFT_N/2]; // 32bit x FFT_N
uint64_t FFTimg[FFT_N/2];
int16_t  FFTamp[FFT_N/2];

int main() {
    int i;
    fft_data_t *fft_data_struct;

    for(i=0;i<512;i++){                                                             // eXgf[^̐ U32700̃TCg
      ad_buf[i] = (int16_t)(32700*sin((float)i * 3.14159265 / 16.0));
      printf("%d,%d\n\r",i,ad_buf[i]);
    }
    printf("\n\r");

    for ( i = 0; i < FFT_N / 2; i++) {                                              // 16bit̃f[^FFT̓͌`64bitf[^ɕׂ@
      fft_data_struct = (fft_data_t*)&databuf512[i];                                // [v̎sԂ10usec
      fft_data_struct->I1 =  0;                // bit 15..0
      fft_data_struct->R1 =  ad_buf[i*2];      // bit 31..16
      fft_data_struct->I2 =  0;                // bit 47..32
      fft_data_struct->R2 =  ad_buf[i*2+1];    // bit 63..48
    }

    fft_complex_uint16_dma(DMAC_CHANNEL0, DMAC_CHANNEL1, FFT_FORWARD_SHIFT, FFT_DIR_FORWARD, databuf512, FFT_N, FFTimg);  // FFT̎s 35usec

    for ( i = 0; i < FFT_N/4; i++) {                                               //FFT̏o͂16bitɕāA傫loǧvZ
      fft_data_struct = (fft_data_t*)&FFTimg[i];                                   //[v̎sԂ560usec
      int16_t imag = fft_data_struct->I1 ;
      int16_t real = fft_data_struct->R1 ;
      FFTamp[2*i] = (int16_t)(10.0*log10(real*real + imag*imag)+0.5);
      imag = fft_data_struct->I2 ;
      real = fft_data_struct->R2 ;
      FFTamp[2*i+1] = (int16_t)(10.0*log10(real*real + imag*imag)+0.5);
    } 

    for ( i = 0; i < FFT_N/2 ; i++) { printf("%d,%d\n\r",i,FFTamp[i]); }           //ʂ[ɏo
    while(1){}
}
